/*
 * Saltine Cracker Internet Client 1.5
 * Copyright (C) 1999 aempirei
 * Revised 03feb99
 * Produced by The Ambient Empire
 * see keds.txt for information
 */

#include "saltine.h"

char *c3_crack(long *, char *, char *);
char *nt_crack(long *, char *);

int ipv4_rslvhost(char *, struct sockaddr_in *);

void showtitle(void);
void showhelp(void);
void keds_io(int, char *, int, char *, int);

int connect2keds(char *);

FILE *fs_scstatus;

int main(int argc, char *argv[]) {
   static char *khost;

   static char kbuffer[1024];
   static char outmsg[32];
   static char sarray[4];
   static char *hfield;
   static long *hfieldb;

   char *results;

   int hashlen;
   int ksock;
   long i, j;

   float status;
   
   showtitle();
   fs_scstatus = stdout;

   /* display help if no arguments specified */
   if(argc == 1) { showhelp(); exit(EXIT_FAILURE); }

   if(test_integrity()) exit(EXIT_FAILURE);

   if(argc > 2) {
      fs_scstatus = fopen(argv[2], "at");
      if(fs_scstatus == NULL) {
	 fprintf(stderr, "ERROR: cannot open %s for output\n", argv[2]);
	 exit(EXIT_FAILURE);
      }

      printf("- status output to \"%s\"\n", argv[2]);
      setvbuf(fs_scstatus, NULL, _IONBF, 0);
   } else printf("- status output to screen\n");
   
   khost = argv[1];

   ksock = connect2keds(khost);
   keds_io(ksock, "mhsg=", 5, kbuffer, 1023);
   close(ksock);

   for(i = 0; kbuffer[i] != '$'; i++) {
      if(fs_scstatus != stdout) fputc(kbuffer[i], stdout);
      fputc(kbuffer[i], fs_scstatus);
   }
   i++;

   hashlen = kbuffer[i] - 'A'; i++;
   hfield = malloc(hashlen + 1);
   memcpy(hfield, &kbuffer[i], hashlen);
   hfield[hashlen] = 0;
   i += hashlen;
   
   j = (kbuffer[i    ] - 'A') * 1296 +
       (kbuffer[i + 1] - 'A') * 36 +
       (kbuffer[i + 2] - 'A');
   status = 100.0 * (float)j / (float)KEYSPACES; i += 3;
   memcpy(sarray, &kbuffer[i], 3);

   fprintf(fs_scstatus, "- hash algorithm: ");
   if(hashlen == C3HASHLEN) fprintf(fs_scstatus, "LibDES Crypt(3)\n");
   else fprintf(fs_scstatus, "MD4 NT Hash\n");

   fprintf(fs_scstatus, "- password field: %s\n", hfield);
   fprintf(fs_scstatus, "- current status: %3.2f%%\n", status);
   fprintf(fs_scstatus, "- current array: \"%s\"\n", sarray);
   
   if(hashlen == C3HASHLEN) {
      hfieldb = (long *)malloc(C3HASHBLEN);
      memcpy(hfieldb, c3atob(&hfield[2]), C3HASHBLEN);
   } else {
      hfieldb = (long *)malloc(NTHASHBLEN);
      memcpy(hfieldb, ntatob(hfield), NTHASHBLEN);
   }

   if(hashlen == C3HASHLEN) {
      while((results = c3_crack(hfieldb, hfield, sarray)) == NULL) {
         putchar('\n');
      
         ksock = connect2keds(khost);

         outmsg[0] = 'p';
         memcpy(&outmsg[1], sarray, 3);
         memcpy(&outmsg[4], "sg=", 3);
      
         keds_io(ksock, outmsg, 7, kbuffer, 1023);
         close(ksock);
      
         j = (kbuffer[0] - 'A') * 1296 +
             (kbuffer[1] - 'A') * 36 +
             (kbuffer[2] - 'A');
         status = 100.0 * (float)j / (float)KEYSPACES;
         memcpy(sarray, &kbuffer[3], 3);
      
         fprintf(fs_scstatus, "- current status: %3.2f%%\n", status);
         fprintf(fs_scstatus, "- current array: \"%s\"\n", sarray);
      }
   } else {
      while((results = nt_crack(hfieldb, sarray)) == NULL) {
         putchar('\n');
      
         ksock = connect2keds(khost);

         outmsg[0] = 'p';
         memcpy(&outmsg[1], sarray, 3);
         memcpy(&outmsg[4], "sg=", 3);
      
         keds_io(ksock, outmsg, 7, kbuffer, 1023);
         close(ksock);
      
         j = (kbuffer[0] - 'A') * 1296 +
             (kbuffer[1] - 'A') * 36 +
             (kbuffer[2] - 'A');
         status = 100.0 * (float)j / (float)KEYSPACES;
         memcpy(sarray, &kbuffer[3], 3);
      
         fprintf(fs_scstatus, "- current status: %3.2f%%\n", status);
         fprintf(fs_scstatus, "- current array: \"%s\"\n", sarray);
      }
   }

   outmsg[ 0] = 'p'; memcpy(&outmsg[1], sarray, 3);
   outmsg[ 4] = 'f'; memcpy(&outmsg[5], results, strlen(results));
   outmsg[5 + strlen(results)] = '=';
   outmsg[6 + strlen(results)] = 0;

   ksock = connect2keds(khost);
   keds_io(ksock, outmsg, strlen(outmsg), kbuffer, 1023);
   close(ksock);

   fprintf(fs_scstatus, "- password: \"%s\"\n", results);
   fprintf(fs_scstatus, "\n[ COMPLETED ]\n");
   exit(EXIT_SUCCESS);
}

void keds_io(int sock, char *outdata,
	     int dsize, char *buffer, int bufsize) {
   int i;

   send(sock, outdata, dsize, 0);

   buffer[0] = 0;
   while(strchr(buffer, '=') == NULL) {
      i = recv(sock, buffer, bufsize, MSG_PEEK);
      buffer[i] = 0;
   }

   recv(sock, buffer, bufsize, 0);
}

int connect2keds(char *host) {
   struct sockaddr_in server;

   int sock;
   
   sock = socket(AF_INET, SOCK_STREAM, 0);
   if(sock == 0) {
      fprintf(stderr, "ERROR: cannot create socket\n");
      exit(EXIT_FAILURE);
   }

   if(!ipv4_rslvhost(host, &server)) {
      fprintf(stderr, "ERROR: cannot resolve %s\n", host);
      close(sock);
      exit(EXIT_FAILURE);
   }
   
   server.sin_family = AF_INET;
   server.sin_port = htons(KEDS_PORT);
   
   if (connect(sock, (SA *)&server, sizeof(server)) < 0) {
      fprintf(stderr, "ERROR: cannot connect to (%s)\n", host);
      close(sock);
      exit(EXIT_FAILURE);
   } else fprintf(fs_scstatus, "- connected to (%s)\n", host);

   return sock;
}

char bin2char[36] = {
   0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x61, 0x62,
   0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E,
   0x6F, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7A
};

char *c3_crack(long *c3_hashb, char c3_hash[], char scanarray[]) {
   static char password[8];

   int i, j, k, l;
   long *cf;
   
   time_t currenttime, lasttime;
   
   password[0] = scanarray[0];
   password[1] = scanarray[1];
   password[2] = scanarray[2];

   fprintf(fs_scstatus, "\n<pass> <cmp/sec> <last cmp> <elapsed>\n");

   lasttime = time(NULL);

   for(i = 0; i < 36; i++) { password[3] = bin2char[i];
      for(j = 35; j + 1; j--) { password[4] = bin2char[j];
	 for(k = 35; k + 1; k--) { password[5] = bin2char[k];
	    for(l = 35; l + 1; l--) { password[6] = bin2char[l];
	       cf = crypt3(password, c3_hash);
	       if((c3_hashb[0] == cf[0]) && (c3_hashb[1] == cf[1]))
		  return password;
	    }
	 }
      }

      if((i + 1) % 4 == 0) {
	 currenttime = time(NULL) - lasttime;

	 fprintf(fs_scstatus, "  %02i   ", i + 1);
	 fprintf(fs_scstatus, "  %5li   ", (46656L * (i + 1)) / currenttime);
	 fprintf(fs_scstatus, " \"%s\" ", password);
	 fprintf(fs_scstatus, " %1li:%02li:%02li\n",  currenttime / 3600,
					             (currenttime % 3600) / 60,
					              currenttime % 60  );
      }
   }
   return NULL;
}

char *nt_crack(long *nt_hashb, char scanarray[]) {
   static char password[9];

   int i, j, k, l, m;
   long *cf;
   
   time_t currenttime, lasttime;
   
   password[0] = scanarray[0];
   password[1] = scanarray[1];
   password[2] = scanarray[2];

   fprintf(fs_scstatus, "\n<pass> <cmp/sec> <last cmp> <elapsed>\n");

   lasttime = time(NULL);

   for(i = 0; i < 36; i++) { password[3] = bin2char[i];
      for(j = 35; j + 1; j--) { password[4] = bin2char[j];
	 for(k = 35; k + 1; k--) { password[5] = bin2char[k];
	    for(l = 35; l + 1; l--) { password[6] = bin2char[l];
	       for(m = 35; m + 1; m--) { password[7] = bin2char[m];
	          cf = nthash(password);
	          if((nt_hashb[0] == cf[0]) &&
                     (nt_hashb[1] == cf[1]) &&
                     (nt_hashb[2] == cf[2]) &&
                     (nt_hashb[3] == cf[3]))
		     return(password);
               }
	    }
	 }
      }

      if((i + 1) % 4 == 0) {
         currenttime = time(NULL) - lasttime;

         fprintf(fs_scstatus, "  %02i   ", i + 1);
         fprintf(fs_scstatus, "  %6li  ", (1679616L / currenttime) * (i + 1));
         fprintf(fs_scstatus, "\"%s\" " , password);
         fprintf(fs_scstatus, " %1li:%02li:%02li\n",  currenttime / 3600,
                                                     (currenttime % 3600) / 60,
				    	              currenttime % 60  );
      }
   }
   return(NULL);
}

void showtitle() {
   fprintf(stderr, "\n    ************************************************************************");
   fprintf(stderr, "\n    * Saltine Cracker Internet Client v1.5          Ambient Empire 03feb99 *");
   fprintf(stderr, "\n    * Copyright (C) 1999 aempirei           see scrack.txt for information *");
   fprintf(stderr, "\n    ************************************************************************\n\n");
}

void showhelp() {
   fprintf(stderr, "\nUSAGE:  scrack <hostname> [outputfile]\n\n");
   fprintf(stderr, "  <hostname>                  the IP address or hostname of the Key\n");
   fprintf(stderr, "                              Distribution Server\n");
   fprintf(stderr, "  [outputfile]                alternate file to store status and messages\n");
   fprintf(stderr, "                              ( default is to the screen )\n");
}
